﻿init python:
    import random
    import time
    random.seed(time.time())
    def get_diagonals(grid, bltr = True):
        dim = len(grid)
        assert dim == len(grid[0])
        return_grid = [[] for total in xrange(2 * len(grid) - 1)]
        for row in xrange(len(grid)):
            for col in xrange(len(grid[row])):
                if bltr:
                    return_grid[row + col].append(grid[col][row])
                else:
                    return_grid[col - row + (dim - 1)].append(grid[row][col])
        return return_grid

    def rotate_list(original):
        return list(zip(*original[::-1]))

    class gomoku_class:
        def __init__(self):
            self.turn = 0
            self.board = []
            for y in range(15):
                row = []
                for x in range(15):
                    row.append([0, x, y])
                self.board.append(row)
            self.won = None

        def place(self, x, y):
            self.board[y][x][0] = self.turn
            if self.turn == 1:
                self.turn = 2
            elif self.turn == 2:
                self.turn = 1
            self.check_for_win()
        def start(self):
            self.turn = 1
        def restart(self):
            self.turn = 1
            self.board = []
            for y in range(15):
                row = []
                for x in range(15):
                    row.append([0, x, y])
                self.board.append(row)
            self.won = None
        def check_for_win(self):
            r = check_rows(self.board)
            if not r:
                r = check_rows(rotate_list(self.board))
            if not r:
                r = check_rows(get_diagonals(self.board))
            if not r:
                r = check_rows(get_diagonals(rotate_list(self.board)))
            if r:
                self.won = r
        def enemy_ai(self):
            move_x = check_for_moves(self.board)
            move_y = check_for_moves(rotate_list(self.board))
            moves = []
            while len(move_x) or len(move_y):
                if len(move_x):
                    x = len(move_x[0])
                else:
                    x = 0
                if len(move_y):
                    y = len(move_y[0])
                else:
                    y = 0
                
                if x == y:
                    r = random.choice(["x","y"])
                elif x > y:
                    r = "x"
                else:
                    r = "y"
                if r == "x":
                    lst = move_x.pop(0)
                    moves.append(["x", lst])
                else:
                    lst = move_y.pop(0)
                    moves.append(["y", lst])


            for i in moves:
                if i[0] == "x":
                    move_1 = self.move_available(i[1][0], -1 , 0)
                    move_2 = self.move_available(i[1][-1], 1 , 0)
                else:
                    move_1 = self.move_available(i[1][0], 0, -1)
                    move_2 = self.move_available(i[1][-1], 0, 1)
                
                if move_1:
                    self.place(move_1[0], move_1[1])
                    break
                elif move_2:
                    self.place(move_2[0], move_2[1])
                    break
            else:
                while 1:
                    x = random.randint(0,14)
                    y = random.randint(0,14)
                    if self.move_available([0,y,x], 0 , 0):
                        self.place(y,x)
                        break


        def move_available(self, slot, xo, yo):
            x = slot[1] + xo
            y = slot[2] + yo
            if x < 0 or x > 14 or y < 0 or y > 14:
                return False
            elif self.board[y][x][0] == 0:
                return [x, y]
            else:
                return False
            


    def check_for_moves(board):
        moves = []
        largest_count = 0
        chains = []
        for j in board:
            side = 0
            row = []
            for i in j:
                if i[0] == 0:
                    pass
                else:
                    if len(row):
                        if row[0][0] == i[0]:
                            row.append(i)
                        else:
                            chains.append(row)
                            row = [i]
                    else:
                        row = [i]
            if len(row):
                chains.append(row)
        random.shuffle(chains)
        chains.sort(key=len)
        chains.reverse()
        return chains
    def check_rows(board, limit = 4):
        side = 0
        count = 0
        poses = []
        for j in board:
            for i in j:
                if i[0] == 0:
                    side = 0
                    count = 0
                    poses = []
                else:
                    if side == i[0]:
                        count += 1
                        poses.append(i)
                    else:
                        side = i[0]
                        count = 1
                        poses = [i]
                if count > limit:
                    return side, poses
        return 0



style gomoku_button:
    background "#fff9"
style gomoku_frame:
    background "#fff9"
style gomoku_text:
    color "#000"

default gomoku_game = gomoku_class()
screen gomoku(g = gomoku_game):
    modal True
    style_prefix "gomoku"
    fixed fit_first True align .5,.5:
        add "Gomoku/chess_board.jpg"
        vbox spacing 6 align .5,.5:
            for y in g.board:
                hbox spacing 6:
                    for x in y:
                        button:
                            xysize 40,40 background None padding 0,0
                            if not x[0] and not g.won:
                                action Function(g.place, x[1], x[2])
                            elif x[0] == 1:
                                add "Gomoku/black_chess.png" align .5,.5
                            elif x[0] == 2:
                                add "Gomoku/white_chess.png" align .5,.5
                            if g.won and x in g.won[1]:
                                add "#0f09"

    if g.turn == 0:
        button align .5,.5:
            text "Start"
            action Function(g.start)
    elif g.turn == 1:
        timer .4 action Function(g.enemy_ai)

    else:
        vbox align 1.0,0.0 offset -40,40 spacing 20:
            frame:
                if g.turn == 1:
                    background "#0f09"
                else:
                    background None

                hbox:
                    add "Gomoku/black_chess.png"
                    text _("Enemy")
            frame:
                if g.turn == 2:
                    background "#0f09"
                else:
                    background None
                hbox:
                    add "Gomoku/white_chess.png"
                    text _("Player")
    if g.won:
        if g.won[0] == 2:
            frame align .5,.5:
                vbox:
                    text "You have won."
                    hbox:
                        button:
                            text "Done"
                            action Return()
                        button:
                            text "Try again."
                            action Function(g.restart)
        elif g.won[0] == 1:
            frame align .5,.5:
                vbox:
                    text "You have lost."
                    hbox:
                        button:
                            text "I've had enough."
                            action Return("skipped")
                        button:
                            text "Try again."
                            action Function(g.restart)

    button align .0,1.0 offset 20, -20 background "#fff9":
        text "Skip"
        action Return("skipped")

label gomoku_example:
    "let's play a game"
    call screen gomoku
    "It was good wasn't it?"
    if _return == "skipped":
        "You've skipped it didn't you?"
    else:
        "Not bad."
